Bug 64597 - Unset PYTHONPATH when shelling to operating system.
Summary: Unset PYTHONPATH when shelling to operating system.
Status: NEW
Alias: None
Product: LibreOffice
Classification: Unclassified
Component: framework (show other bugs)
Version:
(earliest affected)
4.0.1.2 release
Hardware: Other All
: medium normal
Assignee: Not Assigned
URL:
Whiteboard:
Keywords:
Depends on:
Blocks:
 
Reported: 2013-05-14 18:17 UTC by Dave Richards
Modified: 2018-05-23 02:36 UTC (History)
2 users (show)

See Also:
Crash report or crash signature:


Attachments

Note You need to log in before you can comment on or make changes to this bug.
Description Dave Richards 2013-05-14 18:17:39 UTC
When LO shells to the operating system as it does when you use the various functions to attach the document to email; PYTHONPATH should not be passed to the child process.  I believe this change was made for the new .ui screens which expect to use the internal python included with LO. 

If anything with python is calling in these shells, it won't run as expected and is very hard to troubleshoot.  PYTHONPATH overrides the expected behavior of software used to attach files to email systems and/or the email software itself.
Comment 1 Stephan Bergmann 2013-05-15 07:47:14 UTC
Whenever PyUNO is instantiated in-process, prependPythonPath (pyuno/source/loader/pyuno_loader.cxx) adds the content of the PYUNO_LOADER_PYTHONPATH bootstrap variable from the pythonloader.uno ini file (program/pythonloader.unorc on Linux) to the PYTHONPATH environment variable.  (PYUNO_LOADER_PYTHONHOME is handled similarly, but it calls Py_SetPythonHome instead of setting the PYTHONHOME environment variable.  There appears to be no similar Python function to modify the pythonpath, though.)

What would be necessary is coordination between pyuno_loader.cxx and all the places that spawn external processes (hopefully all using the com.sun.star.system.SystemShellExecute UNO service implemented in shell/source/{unix,win32}), to make sure the PYTHONPATH environment variable is back in its original state for any spawned processes.

(A simple way to see this problem on Linux is to have a shell script containing just

  set

and calling it from Basic with the System function, seeing the output in the shell from which soffice was started.)
Comment 2 QA Administrators 2015-03-04 02:22:24 UTC Comment hidden (obsolete)
Comment 3 tommy27 2016-04-16 07:23:37 UTC Comment hidden (obsolete)
Comment 4 QA Administrators 2017-05-22 13:23:54 UTC Comment hidden (obsolete)
Comment 5 Dave Richards 2017-05-22 13:48:46 UTC
Still present in 5.3
Comment 6 QA Administrators 2018-05-23 02:36:42 UTC
** Please read this message in its entirety before responding **

To make sure we're focusing on the bugs that affect our users today, LibreOffice QA is asking bug reporters and confirmers to retest open, confirmed bugs which have not been touched for over a year.

There have been thousands of bug fixes and commits since anyone checked on this bug report. During that time, it's possible that the bug has been fixed, or the details of the problem have changed. We'd really appreciate your help in getting confirmation that the bug is still present.

If you have time, please do the following:

Test to see if the bug is still present with the latest version of LibreOffice from https://www.libreoffice.org/download/

If the bug is present, please leave a comment that includes the information from Help - About LibreOffice.
 
If the bug is NOT present, please set the bug's Status field to RESOLVED-WORKSFORME and leave a comment that includes the information from Help - About LibreOffice.

Please DO NOT

Update the version field
Reply via email (please reply directly on the bug tracker)
Set the bug's Status field to RESOLVED - FIXED (this status has a particular meaning that is not 
appropriate in this case)


If you want to do more to help you can test to see if your issue is a REGRESSION. To do so:
1. Download and install oldest version of LibreOffice (usually 3.3 unless your bug pertains to a feature added after 3.3) from http://downloadarchive.documentfoundation.org/libreoffice/old/

2. Test your bug
3. Leave a comment with your results.
4a. If the bug was present with 3.3 - set version to 'inherited from OOo';
4b. If the bug was not present in 3.3 - add 'regression' to keyword


Feel free to come ask questions or to say hello in our QA chat: https://kiwiirc.com/nextclient/irc.freenode.net/#libreoffice-qa

Thank you for helping us make LibreOffice even better for everyone!

Warm Regards,
QA Team

MassPing-UntouchedBug